Bug 844090 - Review Request: Box2D - A 2D Physics Engine for Games
Review Request: Box2D - A 2D Physics Engine for Games
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Jonathan Dieter
Fedora Extras Quality Assurance
:
Depends On: 845308
Blocks: 844091 844088
  Show dependency treegraph
 
Reported: 2012-07-28 14:40 EDT by Gwyn Ciesla
Modified: 2012-08-06 21:36 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-08-06 21:36:48 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
jdieter: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Gwyn Ciesla 2012-07-28 14:40:02 EDT
Decription:
Box2D is an open source C++ engine for simulating rigid bodies in 2D.
Box2D is developed by Erin Catto and has the zlib license.
While the zlib license does not require acknowledgement,
we encourage you to give credit to Box2D in your product.

SRPM: http://fedorapeople.org/~limb/review/Box2D/Box2D-2.2.1-1.fc17.src.rpm
SPEC: http://fedorapeople.org/~limb/review/Box2D/Box2D.spec
Comment 1 Jonathan Dieter 2012-07-28 15:22:09 EDT
I'm happy to review this.

This package currently builds against a bundled version of freeglut and also bundles glui which isn't currently in Fedora.

I think we should package glui before going further with this.  Thoughts?
Comment 2 Gwyn Ciesla 2012-07-28 15:28:26 EDT
Thanks!

Crud, good catch.  Cutting out the bundled freeglut is easy, but then the bundled glui wants it.  I'll package that up, submit it, and block this with it.
Comment 3 Gwyn Ciesla 2012-07-28 15:37:33 EDT
<headdesk> And naturally glui only builds a static lib out of the box, so I have to make my own solib.  Yaaaay!  I'll get to it soon, but not likely today. :)
Comment 4 Gwyn Ciesla 2012-08-02 11:38:56 EDT
Ok, the glui bug is ready:

https://bugzilla.redhat.com/show_bug.cgi?id=845308

Still working on Box2D's build with system libs.
Comment 5 Gwyn Ciesla 2012-08-02 12:45:02 EDT
SRPM: http://fedorapeople.org/~limb/review/Box2D/Box2D-2.2.1-2.fc17.src.rpm
SPEC: http://fedorapeople.org/~limb/review/Box2D/Box2D.spec

Now without bundled libs.

I tried building numptyphysics against it, and I think there's a version mismatch, so that might take a bit of work.
Comment 6 Jonathan Dieter 2012-08-02 17:04:38 EDT
Package Review
==============

Key:
- = N/A
x = Pass
! = Fail
? = Not evaluated



==== C/C++ ====
[x]: MUST Header files in -devel subpackage, if present.
[x]: MUST ldconfig called in %post and %postun if required.
[x]: MUST Package does not contain any libtool archives (.la)
[x]: MUST Package does not contain kernel modules.
[x]: MUST Package contains no static executables.
[x]: MUST Rpath absent or only used for internal libs.
[x]: MUST Development (unversioned) .so files in -devel subpackage, if
     present.


==== Generic ====
[x]: EXTRA Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: EXTRA Spec file according to URL is the same as in SRPM.
[x]: MUST Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: MUST Package successfully compiles and builds into binary rpms on at
     least one supported primary architecture.
[x]: MUST %build honors applicable compiler flags or justifies otherwise.
[x]: MUST All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: MUST Buildroot is not present
     Note: Unless packager wants to package for EPEL5 this is fine
[!]: MUST Package contains no bundled libraries.
[x]: MUST Changelog in prescribed format.
[!]: MUST Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: Clean is needed only if supporting EPEL
[x]: MUST Sources contain only permissible code or content.
[!]: MUST Each %files section contains %defattr if rpm < 4.4
     Note: defattr(....) present in %files devel section. This is OK if
     packaging for EPEL5. Otherwise not needed
[x]: MUST Macros in Summary, %description expandable at SRPM build time.
[-]: MUST Package contains desktop file if it is a GUI application.
[x]: MUST Development files must be in a -devel package
[x]: MUST Package requires other packages for directories it uses.
[x]: MUST Package uses nothing in %doc for runtime.
[x]: MUST Package is not known to require ExcludeArch.
[x]: MUST Permissions on files are set properly.
[x]: MUST Package does not contain duplicates in %files.
[x]: MUST Fully versioned dependency in subpackages, if present.
[x]: MUST Package complies to the Packaging Guidelines
[x]: MUST Spec file lacks Packager, Vendor, PreReq tags.
[!]: MUST Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf is only needed if supporting EPEL5
[-]: MUST Large documentation files are in a -doc subpackage, if required.
[x]: MUST If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %doc.
[x]: MUST License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "zlib/libpng"
[x]: MUST License file installed when any subpackage combination is installed.
[x]: MUST Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: MUST Package is named using only allowed ascii characters.
[x]: MUST Package is named according to the Package Naming Guidelines.
[x]: MUST Package does not generate any conflict.
     Note: Package contains no Conflicts: tag(s)
[x]: MUST Package obeys FHS, except libexecdir and /usr/target.
[x]: MUST Package must own all directories that it creates.
[x]: MUST Package does not own files or directories owned by other packages.
[x]: MUST Package installs properly.
[x]: MUST Package is not relocatable.
[x]: MUST Requires correct, justified where necessary.
[x]: MUST Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: MUST Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: MUST Spec file is legible and written in American English.
[x]: MUST Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[-]: MUST Package contains systemd file(s) if in need.
[x]: MUST File names are valid UTF-8.
[x]: MUST Useful -debuginfo package or justification otherwise.
[?]: SHOULD Reviewer should test that the package builds in mock.
[x]: SHOULD If the source package does not include license text(s) as a
     separate file from upstream, the packager SHOULD query upstream to
     include it.
[x]: SHOULD Dist tag is present.
[x]: SHOULD No file requires outside of /etc, /bin, /sbin, /usr/bin,
     /usr/sbin.
[x]: SHOULD Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[?]: SHOULD Package functions as described.
[x]: SHOULD Latest version is packaged.
[x]: SHOULD Package does not include license text files separate from
     upstream.
[x]: SHOULD Scriptlets must be sane, if used.
[x]: SHOULD SourceX / PatchY prefixed with %{name}.
[!]: SHOULD SourceX is a working URL.
     Does https://box2d.googlecode.com/files/Box2D_v2.2.1.zip work?
[-]: SHOULD Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: SHOULD Package should compile and build into binary rpms on all supported
     architectures.
[x]: SHOULD %check is present and all tests pass.
[x]: SHOULD Packages should try to preserve timestamps of original installed
     files.
[x]: SHOULD Spec use %global instead of %define.

Issues:
[!]: MUST Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: Clean is needed only if supporting EPEL
See: http://fedoraproject.org/wiki/Packaging/Guidelines#.25clean
[!]: MUST Each %files section contains %defattr if rpm < 4.4
     Note: defattr(....) present in %files devel section. This is OK if
     packaging for EPEL5. Otherwise not needed
See: http://fedoraproject.org/wiki/Packaging/Guidelines#FilePermissions
[!]: MUST Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf is only needed if supporting EPEL5
See: None
[!]: SHOULD SourceX is a working URL.
     Does http://box2d.googlecode.com/files/Box2D_v2.2.1.zip work?
See: http://fedoraproject.org/wiki/Packaging:SourceURL#Referencing_Source

Rpmlint
-------
Checking: Box2D-devel-2.2.1-2.fc17.x86_64.rpm
          Box2D-2.2.1-2.fc17.x86_64.rpm
          Box2D-2.2.1-2.fc17.src.rpm
          Box2D-debuginfo-2.2.1-2.fc17.x86_64.rpm
Box2D-devel.x86_64: W: spelling-error %description -l en_US zlib -> lib, glib, z lib
Box2D-devel.x86_64: W: spelling-error %description -l en_US acknowledgement -> acknowledgment, acknowledged, acknowledge
Box2D.x86_64: W: spelling-error %description -l en_US zlib -> lib, glib, z lib
Box2D.x86_64: W: spelling-error %description -l en_US acknowledgement -> acknowledgment, acknowledged, acknowledge
Box2D.src: W: spelling-error %description -l en_US zlib -> lib, glib, z lib
Box2D.src: W: spelling-error %description -l en_US acknowledgement -> acknowledgment, acknowledged, acknowledge
Box2D.src:54: E: hardcoded-library-path in %{buildroot}/usr/lib
Box2D.src: W: invalid-url Source0: Box2D_v2.2.1.zip
4 packages and 0 specfiles checked; 1 errors, 7 warnings.

The rpmlint error can be ignored as you're moving files from /usr/lib to /usr/lib64.

Rpmlint (installed packages)
----------------------------
# rpmlint Box2D Box2D-debuginfo Box2D-devel
Box2D.x86_64: I: enchant-dictionary-not-found en_US
3 packages and 0 specfiles checked; 0 errors, 0 warnings.
# echo 'rpmlint-done:'

Requires
--------
Box2D-devel-2.2.1-2.fc17.x86_64.rpm (rpmlib, GLIBC filtered):
    
    Box2D = 2.2.1-2.fc17
    libBox2D.so.2.1.0()(64bit)  

Box2D-2.2.1-2.fc17.x86_64.rpm (rpmlib, GLIBC filtered):
    
    /sbin/ldconfig  
    libc.so.6()(64bit)  
    libgcc_s.so.1()(64bit)  
    libgcc_s.so.1(GCC_3.0)(64bit)  
    libm.so.6()(64bit)  
    libstdc++.so.6()(64bit)  
    libstdc++.so.6(CXXABI_1.3)(64bit)  
    rtld(GNU_HASH)  

Box2D-debuginfo-2.2.1-2.fc17.x86_64.rpm (rpmlib, GLIBC filtered):
    

Provides
--------
Box2D-devel-2.2.1-2.fc17.x86_64.rpm:
    
    Box2D-devel = 2.2.1-2.fc17
    Box2D-devel(x86-64) = 2.2.1-2.fc17

Box2D-2.2.1-2.fc17.x86_64.rpm:
    
    Box2D = 2.2.1-2.fc17
    Box2D(x86-64) = 2.2.1-2.fc17
    libBox2D.so.2.1.0()(64bit)  

Box2D-debuginfo-2.2.1-2.fc17.x86_64.rpm:
    
    Box2D-debuginfo = 2.2.1-2.fc17
    Box2D-debuginfo(x86-64) = 2.2.1-2.fc17

SHA-256-sum check
-------------
63184a8ad317e19cd0c3408e14cd808816628b5c8686741dc32664c6f4db3a95 - srpm
63184a8ad317e19cd0c3408e14cd808816628b5c8686741dc32664c6f4db3a95 - separate download

Generated by fedora-review 0.2.0 (53cc903) last change: 2012-07-09
Comment 7 Jonathan Dieter 2012-08-02 17:14:36 EDT
The first three issues can be ignored if you're planning to package this for EPEL-5.  If not, they should probably be fixed.

The fourth issue is a that you could have a proper source url rather than the source plus comment.  I'm not sure if you had a reason for doing it the way you did?

Finally, you could argue that the patches should have comments explaining their necessity and why they're not upstream, but I think the patch names do a good enough job of explaining that.

I'm going to mark this approved, so, after at least the fourth issue is fixed (unless there's a reason for why you didn't do the source url), go ahead and do the CVS request.
Comment 8 Gwyn Ciesla 2012-08-06 12:51:53 EDT
Done, thanks very much!

New Package SCM Request
=======================
Package Name: Box2D
Short Description: A 2D Physics Engine for Games
Owners: limb
Branches:
InitialCC:
Comment 9 Gwyn Ciesla 2012-08-06 12:59:32 EDT
Git done (by process-git-requests).
Comment 10 Gwyn Ciesla 2012-08-06 21:36:48 EDT
Imported and built in rawhide.

Note You need to log in before you can comment on or make changes to this bug.